<?php


/*************************************************************/ 
/**  Cette fonction permet de lancer un script PHP dans un article 
/** 
/**  La syntaxe est la suivante : #INCLURE ( nom_fichier ) 
/** 
/**  Auteur  : F. Quointeau 
/**  Version : 0.0.2 
/**  Date    : 16 Mai 2004 
/*************************************************************/
/** Amnagements : Michel MAILLARD - 20 Aot 2007 
/** 
/** recherche automatise des fichiers dans le dossier de stockage 
/** 		ajout des fonctions ob_....()  
/** 		pour assurer l'affichage  l'emplacement dsir et non en haut de page) 
/** variable $f pour le fichier inclus  
/**		(pour compatibilit avec certains serveurs) 
/** 
/** Ne pas  oublier de placer cette fonction dans les squelettes ad-hoc,  
/** en particulier article.html 
/**		[......(#TEXTE|autoriser_php)........] 
/** 
/*************************************************************/
/** Adaptations: H2Fooko - 20 - jan - 2009
/** 
/** Recherche des scripts PHP AVEC leurs ventuelles URL. 
/**		voir "$chaine_url" ci-dessous
/** Mise en place de l'ide de Jim WANDERSCHEID pour passer des paramtres:
/**		  savoir "parse_str()."
/**  
/*************************************************************/

function autoriser_php( $texte) { 

// Dossier o sont stocks les scripts  
//( partir du fichier spip.php et non  partir du rpertoire squelettes) 
	$dossier_inclus = './my_script_php/'; 

// Les fichiers inclus autorises sont :  
// *.php, *.php3, *.php4 , *.php5, *.phtml, *.htm, *.html, *.inc 
	$fichiers_autorises="(php|php3|php4|php5|phtml|htm|html|inc)"; 

// Recherche des fichiers inclus autoriss dans le dossier de stockage 
	$dir=opendir("$dossier_inclus"); 
	while ($fichier=readdir ($dir)) 
	{ 
		if(( preg_match( $fichiers_autorises, $fichier))) 
		{ 
			$scripts_autorises[]= $fichier; 
		} 
	} 
	closedir($dir); 
// Expression rgulire de recherche de #INCLURE(script.php?var1=XXX&var2=YYY) avec une URL.

	$chaine_url = "((&nbsp;\?(\w)+=(.)+){1}(&amp;(\w)+=(.)+)*)*";
	$chaine_recherche = "/#INCLURE( *)\(( *)([^\)]*\.".$fichiers_autorises.$chaine_url.")( *)\)/i"; 
	while( preg_match( $chaine_recherche, $texte, $resultats)) { 
		$autorise = false; 
		reset( $scripts_autorises); 
		$nom_length = strlen($resultats[3]);
		// SPIP nous a introduit un caractre blanc '&nbsp;' avant le point d'interrogation '?' pour la version franaise.
		$pos_question = strpos($resultats[3],'&nbsp;?');
		// Si la chaine recherche n'existe pas on souhaite prendre la longueur max.
		// dans le cas o il n'y a pas d'URL.
		if ($pos_question === false) 
		{
			$pos_question = $nom_length;
			$nom_url = "";
		} else {
			// le chiffre 7 correspond  la longueur de '&nbsp;?'. On rcupre l'URL aprs le ?.
			$nom_url = substr($resultats[3],$pos_question+7,$nom_length);
			//SPIP convertit le caractre '&' en '&amp;' on refeait l'opration inverse !
			$nom_url = str_replace ("&amp;","&",$nom_url);
		};
		$nom_script = substr($resultats[3],0,$pos_question);
		// Verifie le droit d'inclure ce fichier script ! 
		while( $script = each( $scripts_autorises)) { 
			if( strcasecmp( $script[value], $nom_script) == 0) $autorise = true; 
		} 
		if( $autorise == true) { 
			// Verifie que le fichier existe 
			$f=$dossier_inclus . $nom_script; 
			if( file_exists ($f)) { 
				// Vide le buffer de sortie 
				$affichage_php = '';
				// On cre les variables on on les initialise grce  l'URL.
				parse_str($nom_url);
				// Et lance le fichier inclu !!! 
				ob_start(); 
				include ($f); 
			} else { 
				$affichage_php = "<b>#INCLURE: Le fichier de script $f n'existe pas !</b>"; 
			} 
		} else { 
			$affichage_php = "<b>#INCLURE: Script NON autoris&eacute; !</b>"; 
		} 
		// Attention, n'effectue qu'un seul remplacement  la fois ! 
		$affichage_php = ob_get_contents(); 
		ob_end_clean(); 
		$texte = preg_replace( $chaine_recherche, $affichage_php, $texte, 1); 
	} 
	return( $texte); 
} 

function my_include($fich, $url){
	if ($url[0] === '|'){
		$nom_url = substr($url,1,strpos($url,'>') - 1);
		// Pour tre conforme  la syntaxe accepte par la fonction 'parse_str'.
		$nom_url = str_replace ("|","&",$nom_url);
		parse_str ($nom_url);
	};
	// Dbranche le retour vers le navigateur et renvoie dans un buffer
	ob_start();
	include($fich.'.php');
	// on recupre le buffer
	$retour = ob_get_contents();
	// on vide et ferme le buffer
	ob_end_clean();
	return $retour;
}

function recherche_php($t) {
	$ScriptDir = './my_script_php/';
	$SearchedStrUrl = "/<php_cache_(([^>]+?)([|]{1}((\w)+=(.)+){1}([|]*(\w)+=(.)+)*)*)>/i";
	// on remplace les <php_cache_XX>
	if (preg_match_all($SearchedStrUrl,$t,$mymatches)) {
		for ($i=0;$i<sizeof($mymatches[2]);$i++) {
			$tag = my_include($ScriptDir.$mymatches[2][$i], $mymatches[3][$i]);
			$t = str_replace($mymatches[0][$i],$tag,$t);
		}
	}
	return $t;
}

?>